var express = require('express');
var app = express();
var _ = require('lodash');
var products =require("./data/products").products;

app.use((req,res,next)=>{
    res.header("Content-Type","application/json");
    next();
});

app.get('/products', (req, res)=>{
    respond(()=>{
        return { success:true, data:products};
   },req,res);
})

app.get('/products/:id', (req, res)=>{
    respond(()=>{
       
    var data = _.find(products, (item)=>{
        return item.id == req.params.id;
    });
    if(typeof(data) == 'undefined'){
        res.status(404);
        return { success:false,message:"Invalid product id", data:{}};    
    }
    else
        return { success:true, data:data};
    },req,res);
 })

 function respond(callback,req,res){
    var data = callback();
    if(typeof(data) == 'undefined')
        res.end();
    else    
        res.end(JSON.stringify(data));
 }

var server = app.listen(8081, function () {
  var host = server.address().address
  var port = server.address().port
  console.log("ZYX Commerce API Server listening at http://%s:%s", host, port)
})